/*
	This file is part of "Filter Foundry", a filter plugin for Adobe Photoshop
    Copyright (C) 2002-3 Toby Thain, toby@telegraphics.com.au

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by  
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License  
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "ff.h"

#include "compat_string.h"

void fixpipl(PIPropertyList *pipl,long origsize,long titlesize,StringPtr title){
	PIProperty *prop;

	pipl->count += 2; // two more keys in PiPL

	/* add Title/Name property key */

	prop = (PIProperty*)((char*)pipl + origsize);

	prop->vendorID = kPhotoshopSignature;
	prop->propertyKey = PINameProperty;
	prop->propertyID = 0;
	prop->propertyLength = title[0]+1;
	PLstrcpy((StringPtr)prop->propertyData,title);
	
	/* add Category property key */

	(char*)prop += titlesize;
	
	prop->vendorID = kPhotoshopSignature;
	prop->propertyKey = PICategoryProperty;
	prop->propertyID = 0;
	prop->propertyLength = gdata->parm.category[0]+1;
	PLstrcpy((StringPtr)prop->propertyData,gdata->parm.category);
}
